//====================================
//|HW 2 Solution                     |
//|Lucas Kreger-Stickles             |
//====================================

//This program takes in an 8 char hex string and 
//return the assembly instruction associated
//with the 32 bit instruction represented by the hex string

//The program is divided into two parts:
//main() (which is commented out and also implemented in
//assembly) which sits in a loop printing the prompt and reading
//user input, then passing that input on to disasm() and looping so
//long as disasm returns a non-zero value, terminating else.

//disasm(char* s) takes a char* of length 8 and converts that char* into
//a bitstring and then displays the instruction in assembly code.
//disasm(char* s) returns 0 iff an element of char* is not a hex value, 1 else

int disasm(char* theInst)
{
  int i = 0;
  int inst = 0;
  int opcode; //31-26
  int rs;     //25-21
  int rt;     //20-16
  int rd;     //15-11
  int funct;   //5-0

  char curHex;

  //read in the string and convert to int
  while(theInst[i] != 0)
    {
      inst = inst << 4;
      curHex = (theInst[i]);

      //48 == '0' but c-- won't let you write it as '0'
      if(curHex >= 48 & curHex <= 57)
      {
        inst = inst | (curHex - 48); 
      }
      
      //97 == 'a'
      if(curHex >= 97 & curHex <= 102)
      {
        inst = inst | ((curHex - 97)+10);
      }

      if(curHex < 48 | curHex > 102 | (curHex > 57 & curHex < 97))
	{
	  return 0;
	}

      i = i+1;
    }

  opcode = (inst >> 26) & 0x3F;
  rs = (inst >> 21) & 0x1F;
  rt = (inst >> 16) & 0x1F;
  rd = (inst >> 11) & 0x1F;
  funct = inst & 0x3F;

  if(opcode != 0)
    {
      printString("Not a recognized instruction type.\n");
      return 1;
    }

  if(funct == 32)//ADD
    {
      printString("ADD\t");
    }
  if(funct == 36)//AND
    {
      printString("AND\t");
    }
  if(funct == 13)//break
    {
      printString("break\t");
    }
  if(funct == 26)//DIV
    {
      printString("DIV\t");
    }
  if(funct == 9)//JALR
    {
      printString("JALR\t");
    }
  if(funct == 8)//JR
    {
      printString("JR\t");
    }
  if(funct == 24)//MULT
    {
      printString("MULT\t");
    }
  if(funct == 0)//SLL
    {
      //check if registers are 0, then no-op
      if(rs == 0 & rt == 0 & rd == 0)
	{
	  printString("NO-OP\n");
	  return 1;
	}
      printString("SLL\t");      
    }
  if(funct == 37)//OR
    {
      printString("OR\t");
    }
  if(funct == 42)//SLT
    {
      printString("SLT\t");
    }
  if(funct == 4)//SLLV
    {
      printString("SLLV\t");
    }
  if(funct == 3)//SRA
    {
      printString("SRA\t");
    }
  if(funct == 7)//SRAV
    {
      printString("SRAV\t");
    }
  if(funct == 2)//SRL
    {
      printString("SRL\t");
    }
  if(funct == 6)//SRLV
    {
      printString("SRLV\t");
    }
  if(funct == 34)//SUB
    {
      printString("SUB\t");
    }
  if(funct == 12)//SYSCALL
    {
      printString("SYSCALL\t");
    }
  if(funct == 38)//XOR
    {
      printString("XOR\t");
    }

  //print the instructs op rd rs rt
  printString("$");
  printInt(rd);
  printString(", $");
  printInt(rs);
  printString(", $");
  printInt(rt);
  printString("\n");

  return 1;
}


//int main()
//{
//  //variable declarations:
//  char theInst[9];
//  int legalInst = 1;
//
//  while(legalInst)
//    {
//      //print the prompt
//      printString("Enter a MIPS instruction in hex > 0x");
//      readString(theInst, 9);
//      legalInst = disasm(theInst);
//    }
//  return 1;
//}

